/***************************************************************************/
/* free.h								   */
/*									   */
/* Free storage for the structures defined in spki.h			   */
/***************************************************************************/

#if !defined (__FREE_H__)
#define __FREE_H__


/***************************************************************************/
/* free_init								   */
/*									   */
/* Initialize all free storage pointers to NULL.			   */
/***************************************************************************/

void free_init( void ) ;

/***************************************************************************/
/* free_all								   */
/*									   */
/* Move all in-use blocks to free pools...for rapid use later.		   */
/***************************************************************************/

void free_all( void ) ;

/***************************************************************************/
/* really_free								   */
/*									   */
/* First call free_all then return all free pools to real heaps.	   */
/***************************************************************************/

void really_free( void ) ;

/***************************************************************************/
/* new_bytes								   */
/*									   */
/* Carve and return a new pBytes block					   */
/***************************************************************************/

pBytes new_bytes( void ) ;

/***************************************************************************/
/* drop_bytes								   */
/*									   */
/* Drop h, returning any internal storage and put it on the free list.	   */
/***************************************************************************/

void drop_bytes( pBytes h ) ;

/***************************************************************************/
/* new_sexp								   */
/*									   */
/* Carve and return a new pSexp block					   */
/***************************************************************************/

pSexp new_sexp( void ) ;

/***************************************************************************/
/* drop_sexp								   */
/*									   */
/* Drop h, returning any internal storage and put it on the free list.	   */
/***************************************************************************/

void drop_sexp( pSexp h ) ;

#endif /* __FREE_H__ */
